<template>
  <div class="d-flex right-menu-nav" :style="searchDrawer ? 'width: 100%': 'width: auto;'">
    <!-- SEARCH -->
      <v-text-field
        v-show="searchDrawer"
        ref="searchField"
        v-model="filterSearch"
        autofocus
        class="mr-2 search-drawer"
        :placeholder="$t('common.search')"
        solo
        clearable
        append-icon="mdi-magnify"
        @focus="searchDrawer = true"
        @blur="clickSearch"
        @keyup.enter="submit"
      />

    <!-- PICK FOR ME BUTTON -->
    <v-btn
      v-show="!searchDrawer"
      v-if="!menus.BROWSESTREETWEAR.name && !menus.SHOP.name"
      class="
                                            mt-2
                                            lowercase
                                            br-0
                                            pa-5
                                            font-syne-bold
                                            br-15
                                        "
      color="badge"
      @click="goToPage(menus.HOWPICKFORMEWORKS.id)"
    >
      {{ $t('buttons.pickForMeBtn') }}
    </v-btn>

    <v-btn
      v-show="!searchDrawer"
      icon
      @click="clickSearch"
    >
      <v-img :src="searchIcon" max-width="15" max-height="15" />
    </v-btn>

    <!-- WISHLIST -->
    <v-btn
      v-show="!searchDrawer"
      icon
      @click="goToPage(menus.WISHLIST.id)"
    >
      <v-img :src="wishlistIcon" max-width="15" max-height="15" />
    </v-btn>

    <v-menu v-if="user.id != 0" open-on-hover bottom offset-y>
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          v-show="!searchDrawer"
          icon
          v-bind="attrs"
          v-on="on"
        >
          <v-img
            :src="accountIcon"
            max-width="15"
            max-height="15"
          />
        </v-btn>
      </template>

      <v-list>
        <v-list-item>
          <v-list-item-title>
            <!-- WELCOME BACK -->
            <p v-if="user.id != 0" class="welcome-back">
              <strong>{{ $t('common.welcome') }},
                {{
                  user.firstName + ' ' + user.lastName
                }}</strong>
            </p>
          </v-list-item-title>
        </v-list-item>
        <v-list-item link @click="goToPage(menus.ACCOUNT.id)">
          <v-list-item-title>
            <p
              class="
                                font-14 font-metropolis-regular
                                text-white
                                mb-1
                            "
            >
              {{ $t('dashboard.menu.ACCOUNT') }}
            </p>
          </v-list-item-title>
        </v-list-item>
        <v-list-item link @click="goToPage(menuDashboard.ORDERS.id)">
          <v-list-item-title>
            <p
              class="
                                font-14 font-metropolis-regular
                                text-white
                                mb-1
                            "
            >
              {{ $t('dashboard.menu.ORDERS') }}
            </p>
          </v-list-item-title>
        </v-list-item>
        <v-list-item link @click="goToPage(menuDashboard.SIGNOUT.id)">
          <v-list-item-title>
            <p
              class="
                                font-14 font-metropolis-regular
                                text-white
                                mb-1
                            "
            >
              {{ $t('dashboard.menu.SIGNOUT') }}
            </p>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>

    <!-- ACCOUNT -->
    <v-btn
      v-show="!searchDrawer"
      v-else
      icon
      @click="goToPage(menus.ACCOUNT.id)"
    >
      <v-img :src="accountIcon" max-width="15" max-height="15" />
    </v-btn>

    <!-- BOX -->
    <v-badge
      v-show="!searchDrawer"
      v-if="cartItems.length > 0 && route !== 'shop'"
      bordered
      color="badge"
      :content="cartItems.length > 0 ? cartItems.length : '0'"
      overlap
    >
      <v-btn
        icon
        @click="goToPage(menus.CART.id)"
      >
        <v-img :src="boxIcon" max-width="15" max-height="15" />
      </v-btn>
    </v-badge>

    <!-- FOR GUEST -->
    <v-btn
      v-show="!searchDrawer"
      v-if="
        cartItems.length == 0 &&
          route !== 'shop' &&
          route !== 'shop-checkout' &&
          !routeQuery
      "
      icon
      @click="goToPage(menus.CART.id)"
    >
      <v-img :src="boxIcon" max-width="15" max-height="15" />
    </v-btn>

    <v-badge
      v-show="!searchDrawer"
      v-if="
        (cartShopItems.length > 0 && routeQuery) ||
          route === 'shop' ||
          route === 'shop-checkout'
      "
      bordered
      color="badge"
      :content="cartShopItems.length > 0 ? cartShopItems.length : '0'"
      overlap
    >
      <v-btn
        icon
        @click="goToPage(menus.SHOP.id)"
      >
        <v-img :src="cartIcon" max-width="15" max-height="15" />
      </v-btn>
    </v-badge>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component({
  computed: mapGetters({
    menus: 'menu/getMenu',
    menuDashboard: 'menu/getMenuDashboard',
    getFilter: 'filter/getFilter',
    user: 'user/getUser',
    cartItems: 'cart/getCartItems',
    cartShopItems: 'cart/getCartShopItems'
  })
})
export default class AppBar extends Vue {
    @Prop() route!: String
    @Prop() routeQuery!: String
    @Prop() currentAccountRoute!: any

    menus!: any
    menuDashboard!: any
    searchDrawer: Boolean = false
    filterSearch: string = ''
    searchIcon: String = require('~/assets/images/search.png')
    wishlistIcon: String = require('~/assets/images/wishlist.png')
    accountIcon: String = require('~/assets/images/account.png')
    boxIcon: String = require('~/assets/images/box.png')
    cartIcon: String = require('~/assets/images/cart.png')

    // Methods
    submit () {
      this.$store.commit('filter/setFilterSearchMutation', this.filterSearch)
      this.filterSearch = ''
      if (this.$route.name === 'shop') {
        this.$router.push('/shop')
      } else {
        this.$router.push('/browse')
      }
    }

    goToPage (id: Number) {
      switch (id) {
        case this.menus.BROWSESTREETWEAR.id:
          this.$router.push(this.menus.BROWSESTREETWEAR.path)
          break

        case this.menus.HOWITWORKS.id:
          this.$router.push(this.menus.HOWITWORKS.path)
          break

        case this.menus.PLANS.id:
          this.$router.push(this.menus.PLANS.path)
          break

        case this.menus.ABOUT.id:
          this.$router.push(this.menus.ABOUT.path)
          break

        case this.menus.HOWPICKFORMEWORKS.id:
          this.$router.push(this.menus.HOWPICKFORMEWORKS.path)
          break

        case this.menus.ACCOUNT.id:
          this.currentAccountRoute()
          this.$router.push(this.menus.ACCOUNT.path)
          break

        case this.menus.CART.id:
          if (
            this.$router.currentRoute.name !== 'checkout' &&
                    this.$router.currentRoute.name !== 'browse' &&
                    this.$router.currentRoute.name !== 'shop'
          ) {
            this.$store.commit('drawerbar/setCartDrawer', true)
          }
          break

        case this.menus.SHOP.id:
          this.$router.push(this.menus.SHOP.path)

          break

        case this.menus.WISHLIST.id:
          this.$router.push(this.menus.WISHLIST.path)
          break

        case this.menuDashboard.ORDERS.id:
          this.currentAccountRoute()
          this.$router.push(this.menuDashboard.ORDERS.path)
          break

        case this.menuDashboard.SIGNOUT.id:
          this.logout()
          break

        default:
          this.$router.push('/')
          break
      }
    }

    clickSearch () {
      if (this.searchDrawer) {
        this.searchDrawer = false
        this.$emit('show-search', false)
      } else {
        this.searchDrawer = true
        this.$emit('show-search', true)
      }
    }

    logout () {
      // Remove token cookie
      this.$cookies.remove('t')

      // Remove order cookie
      this.$cookies.remove('o')

      // Remove secret cookie
      this.$cookies.remove('s')

      // Remove token from axios instance
      this.$axios.setToken(false)

      // Clear Stores
      // Clear user profile
      this.$store.commit('user/clearUser')

      // Clear addresses
      this.$store.commit('user/clearAddresses')

      // Clear subscription
      this.$store.commit('subscription/clearSubscription')

      // Clear wishlist
      this.$store.commit('wishlist/clearWishlist')

      // Clear cart
      this.$store.commit('cart/clearCart')

      // Clear shop cart
      this.$store.commit('cart/clearCartShop')

      // Display snackbar
      const val = {
        text: this.$t('snackbar.logoutSuccess'),
        color: 'green',
        icon: 'mdi-check'
      }
      this.$store.dispatch('snackbar/displaySnackBar', val)

      // FB Logout
      // window.FB.logout()

      // Redirect
      this.$router.push('/')
    }
}
</script>
